config/routes.rb
Rails.application.routes.draw do
  resources :rooms do
    resources :users, shallow: true
  end
  get 'rooms/:room_id/users/bulk', to: 'users#bulk', as: 'bulk_new_room_users'
  post 'rooms/:room_id/users/bulk', to: 'users#create_bulk', as: 'bulk_create_room_users'
  post 'rooms/:room_id/users/:id/test_invite', to: 'users#test_invite', as: 'test_invite_user'
  post 'rooms/:room_id/users/invite', to: 'users#invite', as: 'invite_room_users'
  delete 'rooms/:room_id/users', to: 'users#destroy_all', as: 'destroy_room_users'
  delete 'rooms/:room_id/users/invite', to: 'users#uninvite', as: 'uninvite_room_users'
  post 'rooms/:room_id/users/mark_invited', to: 'users#mark_invited', as: 'mark_invited_room_users'
  get 'rooms/:id/aanwezig.csv', to: 'rooms#present', as: 'room_present_users'
  get ':token/aanwezig.csv', to: 'main#users'
  get ':token/stream', to: 'main#stream'
  get ':token', to: 'main#join', as: 'join_room'
  root 'main#index'
end

app/models/user.rb
class User < ApplicationRecord
  belongs_to :room

  attribute :token, :string, default: -> { SecureRandom.hex(16).to_i(16).to_s(36) }
  attribute :moderator, :boolean, default: false
  attribute :invited, :boolean, default: false
  attribute :vote, :boolean, default: true
  attribute :proxy, :boolean, default: false
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  http_basic_authenticate_with name: Rails.application.config.admin_name,
                               password: Rails.application.config.admin_password

  before_action :set_user, only: [:show, :edit, :update, :destroy, :test_invite]
  before_action :set_users, only: [:index, :destroy_all]
  before_action :set_room, only: [:index, :bulk]

  # GET /users
  # GET /users.json
  def index
  end

  # POST /users/invite
  def invite
    @users = User.where(room_id: params[:room_id], invited: false, proxy: false)
    invited = []
    @users.each do |user|
      url = join_room_url(user.token)
      begin
        RoomMailer.with(room_id: params[:room_id], user: user, url: url).invite.deliver_now
        User.find(user.id).update(invited: true)
        invited.push(user.id)
      rescue

      end
    end
    count = invited.length
    respond_to do |format|
      format.html { redirect_to room_users_url, notice: "Sent invitation to #{count} users." }
      format.json { head :no_content }
    end
  end

  # POST /rooms/1/users/1/test_invite
  def test_invite
    url = join_room_url(@user.token)
    RoomMailer.with(room_id: params[:room_id], user: @user, url: url).invite.deliver_now
    respond_to do |format|
      format.html { redirect_to room_users_url, notice: "Sent test invitation." }
      format.json { head :no_content }
    end
  end

  # DELETE /users/invite
  def uninvite
    @users = User.where(room_id: params[:room_id], invited: true)
    count = @users.length
    @users.in_batches.update_all(invited: false)
    respond_to do |format|
      format.html { redirect_to room_users_url, notice: "Reset invitation status of #{count} users." }
      format.json { head :no_content }
    end
  end

  # POST /users/mark_invited
  def mark_invited
    @users = User.where(room_id: params[:room_id], invited: false)
    count = @users.length
    @users.in_batches.update_all(invited: true)
    respond_to do |format|
      format.html { redirect_to room_users_url, notice: "Marked #{count} users as invited." }
      format.json { head :no_content }
    end
  end

  
  # GET /users/1
  # GET /users/1.json
  def show
  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(user_params)
    @user.room_id = params[:room_id]

    respond_to do |format|
      if @user.save
        format.html { redirect_to room_users_url(@user.room_id), notice: 'User was successfully created.' }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to room_users_url(@user.room_id), notice: 'User was successfully updated.' }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to room_users_url(@user.room_id), notice: 'User was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  # DELETE /rooms/1/users/
  # DELETE /rooms/1/users.json
  def destroy_all
    @users.each do |user|
      user.destroy
    end
    respond_to do |format|
      format.html { redirect_to room_users_url(params[:room_id]), notice: 'Users successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  # GET /users/bulk
  def bulk
    @sample = "email,name,moderator,vote,proxy,invited,presence\n,,FALSE,TRUE,FALSE,FALSE,FALSE\n"
  end

  # POST /users/bulk
  # POST /users/bulk.json
  def create_bulk
    room_id = params[:room_id]
    users_csv = params[:users_csv]

    require 'csv'

    CSV.parse(users_csv, :headers => true) do |row|
      fields = row.to_hash
      fields[:room_id] = room_id
      User.create!(fields)
    end

    respond_to do |format|
      format.html { redirect_to room_users_url(room_id), notice: 'Users were successfully created.' }
      format.json { render :show, status: :created, location: @user }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.

    def set_room
      @room = Room.find(params[:room_id])
    end

    def set_user
      @user = User.find(params[:id])
    end

    def set_users
      @users = User.where(room_id: params[:room_id])
    end

    # Only allow a list of trusted parameters through.
    def user_params
      params.require(:user).permit(:name, :email, :token, :moderator, :invited, :vote, :proxy, :presence)
    end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/users/_form.html.erb
<%= form_with(model: user, local: true, url: path) do |form| %>
  <% if user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
        <% user.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="field">
    <%= form.label :email %>
    <%= form.text_field :email %>
  </div>

  <div class="field">
    <%= form.label :moderator %>
    <%= form.check_box :moderator %>
  </div>

  <div class="field">
    <%= form.label :invited %>
    <%= form.check_box :invited %>
  </div>

  <div class="field">
    <%= form.label :vote %>
    <%= form.check_box :vote %>
  </div>

  <div class="field">
    <%= form.label :proxy %>
    <%= form.check_box :proxy %>
  </div>

  <div class="field">
    <%= form.label :presence %>
    <%= form.check_box :presence %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/users/bulk.html.erb
<h1>Bulk Users: <%= @room.name %></h1>

<p>
csv formaat voor bulk import: email,name,moderator,vote,proxy,invited,presence. kolom volgorde maakt niet uit. komma-separated met header.
<% if false %>
download een sample <%= link_to "hier", "/bbb.csv" %>.
<% end %>
</p>

<ul>
<li><code>email</code> wordt het email adres waarop mensen de invites tot vergader systeem BigBlueButton en stem systeem Helios op krijgen. wanneer leden het email opgeven waarmee ze als lid geregistreerd staan vereenvoudigt dit tevens het controle proces op lidmaatschap en woonachtigheid in het afdelingsgebied voor het stemrecht.</li>
<li><code>name</code> is de display naam in BigBlueButton, d.w.z. als iemand daar met pronouns of zonder toenaam in wil dient dat hier gereflecteerd te staan.</li>
<li>zet iedereen op <code>invited=FALSE</code> zodat ze mailtje krijgen met BBB invite</li>
<li><code>moderator=TRUE</code> laat iemand de aanwezige leden uitdraaien dus vergt clearance tot persoonsgegevens. rest <code>FALSE</code>. BigBlueButton moderators kunnen binnen BigBlueButton zelf als dusdanig aangemerkt worden.</li>
<li>leden met stemrecht (afdelingen: woonachtig in afdelingsgebied) krijgen <code>vote=TRUE</code> rest <code>FALSE</code></li>
<li>machtiging voor stemmen delegeren: gedelegeerde entry krijgt naam van machtiger, email van gemachtigde, <code>proxy=TRUE</code>, anderen <code>FALSE</code>.</li>
<li>initiele aanwezigheid (benodigd om stemlink te krijgen) zonder een BBB kamer te hoeven binnengaan, bv bij fysieke aanwezigheid: <code>presence=TRUE</code>, anders <code>FALSE</code>. voor BBB wordt dit op <code>TRUE</code> gezet middels de <code>:token</code> join endpoint, voor de Vimeo stream via de <code>:token/stream</code> endpoint.</li>
</ul>

<%= form_with(local: true) do |form| %>
  <div class="field">
    <%= form.text_area :users_csv, value: @sample %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
  <%= link_to 'Back', room_users_path %>
<% end %>

app/views/users/edit.html.erb
<h1>Editing User</h1>

<%= render 'form', user: @user, path: user_path %>

<%= link_to 'Show', user_path %> |
<%= link_to 'Back', room_users_path(@user.room_id) %>

app/views/users/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Users: <%= @room.name %></h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Email</th>
      <th>Token</th>
      <th>Moderator</th>
      <th>Invited</th>
      <th>Vote</th>
      <th>Proxy</th>
      <th>Presence</th>
      <th colspan="2"></th>
    </tr>
  </thead>

  <tbody>
    <% @users.each do |user| %>
      <tr>
        <td><%= user.name %></td>
        <td><%= user.email %></td>
        <td><%= user.token %></td>
        <td><%= user.moderator %></td>
        <td><%= user.invited %></td>
        <td><%= user.vote %></td>
        <td><%= user.proxy %></td>
        <td><%= user.presence %></td>
        <!--<td><%= link_to 'Show', user_path(user) %></td>-->
        <td><%= link_to 'Edit', edit_user_path(user) %></td>
        <td><%= link_to 'Destroy', user_path(user), method: :delete, data: { confirm: 'Are you sure you wish to destroy this user?' } %></td>
        <td><%= link_to 'Send test invite', test_invite_user_path(params[:room_id], user), method: :post %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New User', new_room_user_path %> |
<%= link_to 'Send Invitations', invite_room_users_path, method: :post, data: { confirm: 'Are you sure you wish to send invitations?' } %> |
<%= link_to 'Reset Invitations', invite_room_users_path, method: :delete, data: { confirm: 'Are you sure you wish to reset all invitations?' } %> |
<%= link_to 'Mark all as invited', mark_invited_room_users_path, method: :post, data: { confirm: 'Are you sure you wish to mark all users as invited?' } %> |
<%= link_to 'Bulk import', bulk_new_room_users_path, method: :get %> |
<%= link_to 'Present Users', room_present_users_path(params[:room_id]) %> |
<%= link_to 'Destroy all', destroy_room_users_path(params[:room_id]), method: :delete %> |
<%= link_to 'Back', room_path(params[:room_id]) %>

app/views/users/new.html.erb
<h1>New User</h1>

<%= render 'form', user: @user, path: room_users_path %>

<%= link_to 'Back', room_users_path %>

app/views/users/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @user.name %>
</p>

<p>
  <strong>Email:</strong>
  <%= @user.email %>
</p>

<p>
  <strong>Token:</strong>
  <%= @user.token %>
</p>

<p>
  <strong>Room:</strong>
  <%= @user.room_id %>
</p>

<p>
  <strong>Moderator:</strong>
  <%= @user.moderator %>
</p>

<p>
  <strong>Invited:</strong>
  <%= @user.invited %>
</p>

<p>
  <strong>Vote:</strong>
  <%= @user.vote %>
</p>

<p>
  <strong>Proxy:</strong>
  <%= @user.proxy %>
</p>

<%= link_to 'Edit', edit_user_path %> |
<%= link_to 'Back', room_users_path(@user.room_id) %>